# -*- coding: utf-8 -*-
#coding: utf-8
#/*
# * Copyright (C) 2010 CruncH  (Crunch.ru@gmail.com)
# *
# * This program is free software; you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation; either version 3 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program; if not, write to the Free Software
# * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# */

import os
import ConfigParser
import SOAPpy
import socket
from PyQt4 import QtGui, QtCore

class CmdLine(QtGui.QLineEdit):
    "QLineEdit с реагированием на клавиши"
    def __init__(self, *args):
        QtGui.QLineEdit.__init__(self, *args)
            
    def keyPressEvent(self, event):
        if event.key()==QtCore.Qt.Key_Enter or event.key()==QtCore.Qt.Key_Return:
            self.emit(QtCore.SIGNAL("EnterPressed"))
        elif event.key()==QtCore.Qt.Key_Up: 
            self.emit(QtCore.SIGNAL("historyUp"))
        elif event.key()==QtCore.Qt.Key_Down:
            self.emit(QtCore.SIGNAL("historyDown"))
        else:
            QtGui.QLineEdit.keyPressEvent(self, event)    
        
class SOAP ():
    """
 класс для удобной работы с SOAP
    """
    def __init__(self,host,login,password,port=7878):
        self._error = 0
        self._error_text = ''
        self.code = 'utf8'
        self.namespace = u'urn:MaNGOS' 
        self.update (host,login,password,port)


    def update (self,host,login,password,port=7878):
        if host.startswith("http://"):
            host = host[7:]
        self.host = host
        self.port = str(port)
        self.password = password
        self.login = login
        self.url = u'http://'+self.login+u':'+self.password+u'@'+self.host+':'+self.port
        self.client = SOAPpy.SOAPProxy(self.url,self.namespace)
        return True
        
    def command (self,cmd):
        try:
            self._error = 0
            return unicode(self.client.executeCommand(command = cmd))
        except socket.error as (errno, strerror):
            self._error_text = u"Ошибка подключения №{0}: {1}".format(errno,strerror.decode('utf8'))
            self._error = 1
            return self._error_text
        except SOAPpy.Errors.HTTPError as  strerror:
            self._error_text = u"Ошибка: %s" % strerror.__str__().decode('utf8').replace('<','').replace('>', '')
            self._error = 1
            return self._error_text
        except SOAPpy.Types.faultType as strerror:
            self._error_text = u"Ошибка: %s" % strerror.__str__().replace('<','').replace('>', '')
            self._error = 1
            return self._error_text


class SoapWidget(QtGui.QWidget):
    def __init__(self,parent=None,login='administrator',password='administrator',host='127.0.0.1',port='7878'):
        QtGui.QWidget.__init__(self,parent)
        self.soap_auth = dict()
        self.soap_history_log = []
        self.soap_history_cursor = 0
        if host is None:
            host = '127.0.0.1'
        if port is None:
            port = "7878"
        #затычка на будущее...
        #чую что нужна будет когда будет реализована работа с сохранением сессий
        if not self.soap_auth:
            self.soap_auth.update({'login':login,'password':password,'host':host,'port':port})


        self.soap_client = SOAP(**self.soap_auth)

        lay = QtGui.QVBoxLayout()
        vlay = QtGui.QHBoxLayout()
        self.label_info = QtGui.QLabel(u'<b>{login}</b>@<i>{host}:{port}</i>'.format(**self.soap_auth))
        self.settings_button = QtGui.QPushButton(u"Настройки",self)
        self.settings_button.setSizePolicy(QtGui.QSizePolicy.Fixed, QtGui.QSizePolicy.Fixed)
        self.connect(self.settings_button,QtCore.SIGNAL('clicked()'),self.soap_setting)
        vlay.addWidget(self.settings_button)
        vlay.addWidget(self.label_info)
        lay.addLayout(vlay)
        self.soap_log = QtGui.QTextBrowser(self)
#        self.soap_log.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignBottom)

        self.soap_cmd = CmdLine()
        self.connect(self.soap_cmd,QtCore.SIGNAL('EnterPressed'),self.soap_exec)
        self.connect(self.soap_cmd,QtCore.SIGNAL('historyUp'),self.soap_history_up)
        self.connect(self.soap_cmd,QtCore.SIGNAL('historyDown'),self.soap_history_down)
#        self.soap_cmd.setReadOnly(True)
        lay.addWidget(self.soap_log)
        lay.addWidget(self.soap_cmd)
        self.label_info.setBuddy(self.soap_cmd)
        self.setLayout(lay)

    def soap_exec(self):
        if len(self.soap_cmd.text())>0:
            cmd = unicode(self.soap_cmd.text())
            self.soap_log.append(u'<b>{0}</b>'.format(cmd))
            response = self.soap_client.command(cmd)
            response = response.replace("\r",'')
            if self.soap_client._error:
                self.soap_log.append(u'<font color=red> {0}</font>'.format(response))
            else:
                self.soap_log.append(response)
                self.soap_history_log.insert(0,cmd)
                self.soap_history_cursor = 0
                self.soap_cmd.clear()
    
    def soap_history_up(self):
        if len(self.soap_history_log)> 1 and self.soap_history_cursor < (len(self.soap_history_log)) :
 #           print self.soap_history_cursor
 #           print self.soap_history_log[self.soap_history_cursor]
            self.soap_cmd.clear()
            self.soap_cmd.insert(self.soap_history_log[self.soap_history_cursor])
            self.soap_history_cursor +=1
 #           print self.soap_cmd.isModified()
#TODO: сделать запоминание уже введеных данных, при листании истории
    def soap_history_down(self):
        if len(self.soap_history_log)> 1 and self.soap_history_cursor > 0 :
            self.soap_history_cursor -=1
  #          print self.soap_history_cursor
  #          print self.soap_history_log[self.soap_history_cursor]
            self.soap_cmd.clear()
            self.soap_cmd.insert(self.soap_history_log[self.soap_history_cursor])
  #          print self.soap_cmd.isModified()
    
    def soap_setting (self):
        stg = SoapSettings(self,**self.soap_auth)
        if stg.exec_():
            self.soap_auth.update({u'login':str(stg.login.text())})
            self.soap_auth.update({u'password':str(stg.password.text())})
            host = str(stg.host.text())
            if host.startswith(u"http://"):
                host = host[7:]
            self.soap_auth.update({u'host':host})
            self.soap_auth.update({u'port':str(stg.port.text())})
            #print self.soap_auth
            self.soap_client.update(**self.soap_auth)
            self.label_info.setText(u'<b>{login}</b>@<i>{host}:{port}</i>'.format(**self.soap_auth))
            self.soap_log.append(u'Настройки изменены на <b>{login}</b>@<i>{host}:{port}</i>'.format(**self.soap_auth))
        stg.destroy()


class SoapSettings(QtGui.QDialog):
    """
    Окно настройки SOAP соединения
    """
    def __init__(self, parent=None,login=None,password=None,host=None,port=None):
        QtGui.QDialog.__init__(self, parent)

        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Fixed, QtGui.QSizePolicy.Fixed)
        self.setWindowTitle(u'Настройка SOAP клиента')
        self.setFixedSize(230,170)

        boxlay = QtGui.QGridLayout(self)
        label_login = QtGui.QLabel(u'&Логин:')
        label_login.setAlignment(QtCore.Qt.Alignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignVCenter))
        self.login = QtGui.QLineEdit(u"", self) # поле ввода
        self.login.setMaxLength(32)
        login_re = ur'[a-zA-Z0-9]{2,32}'
        self.login.setValidator(QtGui.QRegExpValidator(QtCore.QRegExp(login_re),self))
        if login:
            self.login.insert(login)
        label_login.setBuddy(self.login)
        boxlay.addWidget(self.login,0,1)
        boxlay.addWidget(label_login,0,0)

        label_pass = QtGui.QLabel(u'&Пароль:')
        label_pass.setAlignment(QtCore.Qt.Alignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignVCenter))
        self.password = QtGui.QLineEdit(u'',self)
        self.password.setMaxLength(40)
        self.password.setEchoMode(QtGui.QLineEdit.Password)
        if password:
            self.password.insert(password)
        label_pass.setBuddy(self.password)
        boxlay.addWidget(self.password,1,1)
        boxlay.addWidget(label_pass,1,0)

        label_host = QtGui.QLabel(u'&Хост:')
        label_host.setAlignment(QtCore.Qt.Alignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignVCenter))
        host_box = QtGui.QHBoxLayout()
        label_http = QtGui.QLabel(u'http://')
        self.host = QtGui.QLineEdit(u"127.0.0.1", self) # поле ввода
        self.host.setMaxLength(50)
        host_re = ur'[a-zA-Z0-9\.]{3,50}'
        self.host.setValidator(QtGui.QRegExpValidator(QtCore.QRegExp(host_re),self))
        if host:
            self.host.clear()
            self.host.insert(host)
        host_box.addWidget(label_http)
        host_box.addWidget(self.host)
        label_host.setBuddy(self.host)
        boxlay.addLayout(host_box,2,1)
        boxlay.addWidget(label_host,2,0)

        label_port = QtGui.QLabel(u'П&орт:')
        label_port.setAlignment(QtCore.Qt.Alignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignVCenter))
        boxlay.addWidget(label_port,3,0)
        self.port = QtGui.QLineEdit(u"7878", self) # поле ввода
        self.port.setSizePolicy(sizePolicy)
        port_validator=QtGui.QIntValidator(1,65536,self)
        self.port.setValidator(port_validator)
        self.port.setMinimumSize(QtCore.QSize(55, 25))
        self.port.setMaximumSize(QtCore.QSize(55, 25))
        if port:
            self.port.clear()
            self.port.insert(port)
        label_port.setBuddy(self.port)
        boxlay.addWidget(self.port,3,1)

        buttonBox = QtGui.QDialogButtonBox(QtGui.QDialogButtonBox.Ok|QtGui.QDialogButtonBox.Cancel)
        self.connect(buttonBox, QtCore.SIGNAL('accepted()'), lambda: self.validate())
        self.connect(buttonBox, QtCore.SIGNAL('rejected()'), lambda: self.done(0))
        boxlay.addWidget(buttonBox,4,0,4,2)

    def validate (self):
        if self.login.text() and self.password.text() and self.host.text():
            self.done(1)
        else:
            QtGui.QMessageBox.critical(self,u'Ошибка',u'Заполнены не все поля')


